Page MenuHomePhabricator

efl_ui_spin_button: add tests for direct input feature
ClosedPublic

Authored by bu5hm4n on Jan 3 2020, 10:39 AM.

Details

Summary

this simply passes in some key sequences and checks if the validation is
working. Additionally the output value is checked.
Depends on D11009

Depends on D11597

Diff Detail

Repository
rEFL core/efl
Lint
Automatic diff as part of commit; lint not applicable.
Unit
Automatic diff as part of commit; unit tests not applicable.
bu5hm4n created this revision.Jan 3 2020, 10:39 AM

It seems that this patch has no reviewers specified. If you are unsure who can review your patch, please check this wiki page and see if anyone can be added: https://phab.enlightenment.org/w/maintainers_reviewers/

This revision was not accepted when it landed; it landed in state Needs Review.Jan 13 2020, 6:58 AM
Closed by commit rEFLf62cee28cbb6: efl_ui_spin_button: add tests for direct input feature (authored by Marcel Hollerbach <mail@marcel-hollerbach.de>). · Explain Why
This revision was automatically updated to reflect the committed changes.
bu5hm4n reopened this revision.Jan 13 2020, 11:18 AM
bu5hm4n updated this revision to Diff 28124.Jan 13 2020, 11:19 AM
bu5hm4n edited the summary of this revision. (Show Details)

more work on this

This is still failing on travis in a Segfault that i cannot reproduce here locally.

@segfaultxavi is this also failing for you ?

Still failing for me, same place :(

../src/tests/elementary/efl_ui_test_spin_button.c:222:E:efl_ui_spin_button:spin_direct_text_input:0: (after this point) Received signal 11 (Segmentation fault)
../src/tests/elementary/efl_ui_test_spin_button.c:222:E:efl_ui_spin_button:spin_direct_text_input_comma_value:0: (after this point) Received signal 11 (Segmentation fault)

Can you now get a backtrace ? One thing is the crash with all details, but at a minimum thing the symbol names would be very good.

Well, it took a looooong time to find the exact combination of meson parameters that reproduce the problem AND have debug info:

-Dbuildtype=release -Doptimization=3 -Ddebug=true

Here's the backtrace:

*** stack smashing detected ***: <unknown> terminated

#0  __GI_raise (sig=sig@entry=6) at ../sysdeps/unix/sysv/linux/raise.c:51
#1  0x00007ffff5025801 in __GI_abort () at abort.c:79
#2  0x00007ffff506e897 in __libc_message (action=action@entry=do_abort, fmt=fmt@entry=0x7ffff519b988 "*** %s ***: %s terminated\n") at ../sysdeps/posix/libc_fatal.c:181
#3  0x00007ffff5119cd1 in __GI___fortify_fail_abort (need_backtrace=need_backtrace@entry=false, msg=msg@entry=0x7ffff519b966 "stack smashing detected") at fortify_fail.c:33
#4  0x00007ffff5119c92 in __stack_chk_fail () at stack_chk_fail.c:29
#5  0x00007ffff77d478a in efl_ui_relative_container_relation_top_get (obj=0x4000000255cf, child=child@entry=0x0, base=base@entry=0x7fffffffdb38, relative_position=relative_position@entry=0x7fffffffdb40)
    at src/lib/elementary/efl_ui_relative_container.eo.c:42
#6  0x000055555558c18f in efl_ui_relative_container_relation_set (_i=<optimized out>) at ../src/tests/elementary/efl_ui_test_relative_container.c:293
#7  0x00005555555b61eb in tcase_run_tfun_nofork.isra ()
#8  0x00005555555b65ac in srunner_run ()
#9  0x0000555555565cf0 in _efl_suite_run_end (name=0x0, sr=0x555555bc2f80) at ../src/tests/elementary/../efl_check.h:282
#10 _efl_suite_build_and_run (suite_name=0x5555555b6f5b "Efl_Ui", etc=0x5555557d7440 <etc>, init=<optimized out>, shutdown=<optimized out>, argv=0x7fffffffde80, argc=0) at ../src/tests/elementary/../efl_check.h:439
#11 main (argc=1, argv=0x7fffffffde78) at ../src/tests/elementary/efl_ui_suite.c:64

Something has destroyed the stack before that point, apparently.
At least, I hope you can reproduce now with that configuration.

Mhm, i will check it out - However, this is a totally different test than the test above, so stack smashing does not matter for the test that is failing for you?

I dunno. This is the first place where gdb stops.

bu5hm4n updated this revision to Diff 28400.Jan 22 2020, 12:23 PM

remove the line that causes errors

bu5hm4n updated this revision to Diff 29390.Sun, Mar 8, 3:39 AM
bu5hm4n edited the summary of this revision. (Show Details)

rebase and add missing test code back

So the big blocker for this test (cnp) is now resolved. The only problematic part left is ecore_audio. Which is not freed right now. However, if we free it, pulseaudio is falling over its own feat ... :/

@zmike you said i should ping you with this when this is done.

zmike requested changes to this revision.Wed, Mar 25, 6:33 AM

Not to be too much of a stickler, but can you split the util functions into a separate patch for ease of blaming?

This revision now requires changes to proceed.Wed, Mar 25, 6:33 AM
This revision was not accepted when it landed; it landed in state Needs Revision.Wed, Mar 25, 2:21 PM
Closed by commit rEFLf6cb2340701f: efl_ui_spin_button: add tests for direct input feature (authored by Marcel Hollerbach <mail@marcel-hollerbach.de>). · Explain Why
This revision was automatically updated to reflect the committed changes.